<template>
	<div :id="id" class="u-block-spacing" :class="$style.block">
		<GlobalEvents target="window" @resize="debouncedResize" />
		<div class="u-wrap">
			<h2 v-if="heading" class="u-heading u-heading--pre-line" :class="$style.heading">{{ heading }}</h2>

			<p v-if="description" class="u-subheading u-subheading--pre-line" :class="$style.description">
				{{ description }}
			</p>

			<div v-if="isCarousel" :class="$style.carouselWrapper">
				<MoleculeCarousel :autoplay="false" :has-navigation="false">
					<MoleculeCarouselSlide
						v-for="(slide, slideIndex) in slides"
						:key="slideIndex"
						:slide-index="slideIndex"
						:class="$style.slide"
					>
						<blockquote v-for="(post, postIndex) in slide" :key="postIndex" :class="$style.post">
							<h3 v-if="post.comment" class="u-font-secondary" :class="$style.comment">“{{ post.comment }}”</h3>

							<div
								v-if="(post.imageMobile && post.imageMobile.url) || (post.image && post.image.url)"
								:class="$style.image"
							>
								<BaseImage
									:image="post.imageMobile || {}"
									:images="{ medium: post.image || {} }"
									sizes="(min-width: 1200px) 313px, (min-width: 1024px) calc((100vw - 100px) * 0.25), (min-width: 768px) calc((100vw - 60px) * 0.5), calc(100vw - 40px)"
									compression-level="medium"
									:params="{ cs: 'strip' }"
								/>
							</div>

							<footer v-if="post.author" :class="$style.author">
								{{ post.author }}
							</footer>
						</blockquote>
					</MoleculeCarouselSlide>
				</MoleculeCarousel>
			</div>

			<div v-else :class="$style.listing">
				<blockquote v-for="(post, postIndex) in posts" :key="postIndex" :class="$style.post">
					<h3 v-if="post.comment" class="u-font-secondary" :class="$style.comment">“{{ post.comment }}”</h3>

					<div
						v-if="(post.imageMobile && post.imageMobile.url) || (post.image && post.image.url)"
						:class="$style.image"
					>
						<BaseImage
							:image="post.imageMobile || {}"
							:images="{ medium: post.image || {} }"
							sizes="(min-width: 1200px) 313px, (min-width: 1024px) calc((100vw - 100px) * 0.25), (min-width: 768px) calc((100vw - 60px) * 0.5), calc(100vw - 40px)"
							compression-level="medium"
							:params="{ cs: 'strip' }"
						/>
					</div>

					<footer v-if="post.author" :class="$style.author">
						{{ post.author }}
					</footer>
				</blockquote>
			</div>
		</div>
	</div>
</template>

<script>
import MoleculeCarousel from '@components/molecule-carousel';
import MoleculeCarouselSlide from '@components/molecule-carousel-slide';
import debounce from 'lodash/debounce';
import { chunkArray } from '@/utils';

export default {
	components: {
		MoleculeCarousel,
		MoleculeCarouselSlide,
	},

	props: {
		id: {
			type: String,
			default: null,
		},

		heading: {
			type: String,
			default: '',
		},

		description: {
			type: String,
			default: '',
		},

		posts: {
			type: Array,
			default: () => [],
		},
	},

	data() {
		return {
			windowWidth: 0,
			debouncedResize: debounce(this.handleResize, 100),
		};
	},

	computed: {
		isCarousel() {
			return this.windowWidth ? this.windowWidth < this.$style.breakpoint : false;
		},

		slides() {
			const { windowWidth, posts } = this;

			if (windowWidth < 768) {
				return chunkArray(posts, 1);
			}

			return chunkArray(posts, 2);
		},
	},

	mounted() {
		this.windowWidth = window.innerWidth;
	},

	methods: {
		handleResize() {
			this.windowWidth = window.innerWidth;
		},
	},
};
</script>

<style lang="scss" module>
@import '@design';

.block {
	padding: 0 size('s');
}

.slide {
	display: flex;
}

.carouselWrapper {
	margin: size('s') / -2;
}

.listing {
	@include above('medium') {
		display: flex;
		flex-wrap: wrap;
		margin: 0 size('s') / -2 -1 * size('m');
	}
}

.post {
	display: flex;
	flex-direction: column;
	padding: 0 size('s') / 2;

	@include above('medium') {
		flex: 0 0 auto;
		width: 50%;
		margin-bottom: size('m');
	}

	@include above('large') {
		width: 25%;
	}
}

.comment {
	flex: 1 0 auto;
	order: -2;
	margin-bottom: size('s');
	word-wrap: break-word;
	overflow-wrap: break-word;

	@include use-text-style('heading-200');
}

.author {
	@include use-text-style('type-100');

	order: -1;
	margin-bottom: size('s');
}

:export {
	/* stylelint-disable-next-line property-no-unknown */
	breakpoint: 1024;
}
</style>
